without type_check
include opcodes.e
include val.e
include misc.e
sequence variables, stack, callstack, code
integer ip
procedure Putsl(object x)
    puts(1,x)
end procedure
procedure Putsv(integer x)
    puts(1,variables[x])
end procedure
procedure Printl(object x)
    ? x
end procedure
procedure Printv(integer x)
    ? variables[x]
end procedure
procedure Timel(integer x)
    variables[x] = time()
end procedure
procedure Loopll(integer label, integer v)
    variables[v] -= 1
    if variables[v] then
	ip = label
    end if
end procedure
procedure Loopvl(integer label, integer v)
    variables[v] -= 1
    if variables[v] then
	ip = variables[label]
    end if
end procedure
procedure Loopnll(integer label, integer n)
    integer ipNow
    sequence c
    ipNow = ip-1
    for i = 1 to n do
	ip = label
	while ip != ipNow do
	    c = code[ip]
	    ip += 1
	    call_proc(c[1],c[2])
	end while
    end for
    ip = ipNow + 1
end procedure
procedure Loopnlv(integer label, integer n)
    integer ipNow
    sequence c
    ipNow = ip-1
    for i = 1 to variables[n] do
	ip = label
	while ip != ipNow do
	    c = code[ip]
	    ip += 1
	    call_proc(c[1],c[2])
	end while
    end for
    ip = ipNow + 1
end procedure
procedure Loopnvl(integer label, integer n)
    integer ipNow
    sequence c
    ipNow = ip-1
    label = variables[label]
    for i = 1 to n do
	ip = label
	while ip != ipNow do
	    c = code[ip]
	    ip += 1
	    call_proc(c[1],c[2])
	end while
    end for
    ip = ipNow + 1
end procedure
procedure Loopnvv(integer label, integer n)
    integer ipNow
    sequence c
    ipNow = ip-1
    label = variables[label]
    for i = 1 to variables[n] do
	ip = label
	while ip != ipNow do
	    c = code[ip]
	    ip += 1
	    call_proc(c[1],c[2])
	end while
    end for
    ip = ipNow + 1
end procedure
procedure Calll(integer r)
    callstack &= ip
    ip = r
end procedure
procedure Callv(integer r)
    callstack &= ip
    ip = variables[r]
end procedure
procedure Movll(integer v, object x)
    variables[v] = x
end procedure
procedure Movlv(integer v, integer x)
    variables[v] = variables[x]
end procedure
procedure Movdilll(integer v, object x, integer index)
    variables[v][index] = x
end procedure
procedure Movdilvv(integer v, integer x, integer index)
    variables[v][variables[index]] = variables[x]
end procedure
procedure Movdillv(integer v, object x, integer index)
    variables[v][variables[index]] = x
end procedure
procedure Movdilvl(integer v, integer x, integer index)
    variables[v][index] = variables[x]
end procedure
procedure Movsilll(integer v, sequence x, integer index)
    variables[v] = x[index]
end procedure
procedure Movsilvl(integer v, integer x, integer index)
    variables[v] = variables[x[index]]
end procedure
procedure Movsillv(integer v, sequence x, integer index)
    variables[v] = x[variables[index]]
end procedure
procedure Movsilvv(integer v, integer x, integer index)
    variables[v] = variables[x][variables[index]]
end procedure
procedure Addll(integer v, object x)
    variables[v] += x
end procedure
procedure Addlv(integer v, integer x)
    variables[v] += variables[x]
end procedure
procedure Subll(integer v, object x)
    variables[v] -= x
end procedure
procedure Sublv(integer v, integer x)
    variables[v] -= variables[x]
end procedure
procedure Mulll(integer v, object x)
    variables[v] *= x
end procedure
procedure Mullv(integer v, integer x)
    variables[v] *= variables[x]
end procedure
procedure Divll(integer v, object x)
    variables[v] /= x
end procedure
procedure Divlv(integer v, integer x)
    variables[v] /= variables[x]
end procedure
procedure Andll(integer v, object x)
    variables[v] = variables[v] and x
end procedure
procedure Andlv(integer v, integer x)
    variables[v] = variables[v] and variables[x]
end procedure
procedure Orll(integer v, object x)
    variables[v] = variables[v] or x
end procedure
procedure Orlv(integer v, integer x)
    variables[v] = variables[v] or variables[x]
end procedure
procedure Xorll(integer v, object x)
    variables[v] = variables[v] xor x
end procedure
procedure Xorlv(integer v, integer x)
    variables[v] = variables[v] xor variables[x]
end procedure
procedure Notl(integer v)
    variables[v] = not variables[v]
end procedure
procedure Movlenll(integer v, sequence x)
    variables[v] = length(x)
end procedure
procedure Movlenlv(integer v, integer x)
    variables[v] = length(variables[x])
end procedure
procedure Repeatll(integer v, integer count)
    variables[v] = repeat(variables[v],count)
end procedure
procedure Repeatlv(integer v, integer count)
    variables[v] = repeat(variables[v],variables[count])
end procedure
procedure Appendll(integer v, object x)
    variables[v] = append(variables[v],x)
end procedure
procedure Appendlv(integer v, integer x)
    variables[v] = append(variables[v],variables[x])
end procedure
procedure Prependll(integer v, object x)
    variables[v] = prepend(variables[v],x)
end procedure
procedure Prependlv(integer v, integer x)
    variables[v] = prepend(variables[v],variables[x])
end procedure
procedure Concenll(integer v, object x)
    variables[v] &= x
end procedure
procedure Concenlv(integer v, integer x)
    variables[v] &= variables[x]
end procedure
procedure Isintegerll(object x, integer rv)
    variables[rv] = integer(x)
end procedure
procedure Isintegervl(integer x, integer rv)
    variables[rv] = integer(variables[x])
end procedure
procedure Isatomll(object x, integer rv)
    variables[rv] = atom(x)
end procedure
procedure Isatomvl(integer x, integer rv)
    variables[rv] = atom(variables[x])
end procedure
procedure Issequencell(object x, integer rv)
    variables[rv] = sequence(x)
end procedure
procedure Issequencevl(integer x, integer rv)
    variables[rv] = sequence(variables[x])
end procedure
procedure Andbitsll(integer v, object x)
    variables[v] = and_bits(variables[v],x)
end procedure
procedure Andbitslv(integer v, integer x)
    variables[v] = and_bits(variables[v],variables[x])
end procedure
procedure Orbitsll(integer v, object x)
    variables[v] = or_bits(variables[v],x)
end procedure
procedure Orbitslv(integer v, integer x)
    variables[v] = or_bits(variables[v],variables[x])
end procedure
procedure Xorbitsll(integer v, object x)
    variables[v] = xor_bits(variables[v],x)
end procedure
procedure Xorbitslv(integer v, integer x)
    variables[v] = xor_bits(variables[v],variables[x])
end procedure
procedure Notbitsl(integer v)
    variables[v] = not_bits(variables[v])
end procedure
procedure Floorl(integer v)
    variables[v] = floor(variables[v])
end procedure
procedure Sqrtl(integer v)
    variables[v] = sqrt(v)
end procedure
procedure Remainderll(integer v, object x)
    variables[v] = remainder(variables[v],x)
end procedure
procedure Remainderlv(integer v, integer x)
    variables[v] = remainder(variables[v],variables[x])
end procedure
procedure Randll(integer v, integer max)
    variables[v] = rand(max)
end procedure
procedure Randlv(integer v, integer max)
    variables[v] = rand(variables[max])
end procedure
procedure Sinl(integer v)
    variables[v] = sin(variables[v])
end procedure
procedure Cosl(integer v)
    variables[v] = cos(variables[v])
end procedure
procedure Tanl(integer v)
    variables[v] = tan(variables[v])
end procedure
procedure Asinl(integer v)
    variables[v] = arcsin(variables[v])
end procedure
procedure Acosl(integer v)
    variables[v] = arccos(variables[v])
end procedure
procedure Atanl(integer v)
    variables[v] = arctan(variables[v])
end procedure
procedure Logl(integer v)
    variables[v] = log(v)
end procedure
procedure Powerll(integer v, object x)
    variables[v] = power(variables[v],x)
end procedure
procedure Powerlv(integer v, integer x)
    variables[v] = power(variables[v],variables[x])
end procedure
procedure Sell(atom a, atom b)
    if a = b then
	ip += 1
    end if
end procedure
procedure Selv(atom a, integer b)
    if a = variables[b] then
	ip += 1
    end if
end procedure
procedure Sevl(integer a, atom b)
    if variables[a] = b then
	ip += 1
    end if
end procedure
procedure Sevv(integer a, integer b)
    if variables[a] = variables[b] then
	ip += 1
    end if
end procedure
procedure Snell(atom a, atom b)
    if a != b then
	ip += 1
    end if
end procedure
procedure Snelv(atom a, integer b)
    if a != variables[b] then
	ip += 1
    end if
end procedure
procedure Snevl(integer a, atom b)
    if variables[a] != b then
	ip += 1
    end if
end procedure
procedure Snevv(integer a, integer b)
    if variables[a] != variables[b] then
	ip += 1
    end if
end procedure
procedure Slell(atom a, atom b)
    if a <= b then
	ip += 1
    end if
end procedure
procedure Slelv(atom a, integer b)
    if a <= variables[b] then
	ip += 1
    end if
end procedure
procedure Slevl(integer a, atom b)
    if variables[a] <= b then
	ip += 1
    end if
end procedure
procedure Slevv(integer a, integer b)
    if variables[a] <= variables[b] then
	ip += 1
    end if
end procedure
procedure Sgell(atom a, atom b)
    if a >= b then
	ip += 1
    end if
end procedure
procedure Sgelv(atom a, integer b)
    if a >= variables[b] then
	ip += 1
    end if
end procedure
procedure Sgevl(integer a, atom b)
    if variables[a] >= b then
	ip += 1
    end if
end procedure
procedure Sgevv(integer a, integer b)
    if variables[a] >= variables[b] then
	ip += 1
    end if
end procedure
procedure Slll(atom a, atom b)
    if a < b then
	ip += 1
    end if
end procedure
procedure Sllv(atom a, integer b)
    if a < variables[b] then
	ip += 1
    end if
end procedure
procedure Slvl(integer a, atom b)
    if variables[a] < b then
	ip += 1
    end if
end procedure
procedure Slvv(integer a, integer b)
    if variables[a] < variables[b] then
	ip += 1
    end if
end procedure
procedure Sgll(atom a, atom b)
    if a > b then
	ip += 1
    end if
end procedure
procedure Sglv(atom a, integer b)
    if a > variables[b] then
	ip += 1
    end if
end procedure
procedure Sgvl(integer a, atom b)
    if variables[a] > b then
	ip += 1
    end if
end procedure
procedure Sgvv(integer a, integer b)
    if variables[a] > variables[b] then
	ip += 1
    end if
end procedure
procedure Jelll(atom a, atom b, integer rv)
    if a = b then
	ip = rv
    end if
end procedure
procedure Jevll(integer a, atom b, integer rv)
    if variables[a] = b then
	ip = rv
    end if
end procedure
procedure Jelvl(atom a, integer b, integer rv)
    if a = variables[b] then
	ip = rv
    end if
end procedure
procedure Jevvl(integer a, integer b, integer rv)
    if variables[a] = variables[b] then
	ip = rv
    end if
end procedure
procedure Jnelll(atom a, atom b, integer rv)
    if a != b then
	ip = rv
    end if
end procedure
procedure Jnevll(integer a, atom b, integer rv)
    if variables[a] != b then
	ip = rv
    end if
end procedure
procedure Jnelvl(atom a, integer b, integer rv)
    if a != variables[b] then
	ip = rv
    end if
end procedure
procedure Jnevvl(integer a, integer b, integer rv)
    if variables[a] != variables[b] then
	ip = rv
    end if
end procedure
procedure Jllll(atom a, atom b, integer rv)
    if a < b then
	ip = rv
    end if
end procedure
procedure Jlvll(integer a, atom b, integer rv)
    if variables[a] < b then
	ip = rv
    end if
end procedure
procedure Jllvl(atom a, integer b, integer rv)
    if a < variables[b] then
	ip = rv
    end if
end procedure
procedure Jlvvl(integer a, integer b, integer rv)
    if variables[a] < variables[b] then
	ip = rv
    end if
end procedure
procedure Jglll(atom a, atom b, integer rv)
    if a > b then
	ip = rv
    end if
end procedure
procedure Jgvll(integer a, atom b, integer rv)
    if variables[a] > b then
	ip = rv
    end if
end procedure
procedure Jglvl(atom a, integer b, integer rv)
    if a > variables[b] then
	ip = rv
    end if
end procedure
procedure Jgvvl(integer a, integer b, integer rv)
    if variables[a] > variables[b] then
	ip = rv
    end if
end procedure
procedure Jlelll(atom a, atom b, integer rv)
    if a <= b then
	ip = rv
    end if
end procedure
procedure Jlevll(integer a, atom b, integer rv)
    if variables[a] <= b then
	ip = rv
    end if
end procedure
procedure Jlelvl(atom a, integer b, integer rv)
    if a <= variables[b] then
	ip = rv
    end if
end procedure
procedure Jlevvl(integer a, integer b, integer rv)
    if variables[a] <= variables[b] then
	ip = rv
    end if
end procedure
procedure Jgelll(atom a, atom b, integer rv)
    if a >= b then
	ip = rv
    end if
end procedure
procedure Jgevll(integer a, atom b, integer rv)
    if variables[a] >= b then
	ip = rv
    end if
end procedure
procedure Jgelvl(atom a, integer b, integer rv)
    if a >= variables[b] then
	ip = rv
    end if
end procedure
procedure Jgevvl(integer a, integer b, integer rv)
    if variables[a] >= variables[b] then
	ip = rv
    end if
end procedure
procedure Jellv(atom a, atom b, integer rv)
    if a = b then
	ip = variables[rv]
    end if
end procedure
procedure Jevlv(integer a, atom b, integer rv)
    if variables[a] = b then
	ip = variables[rv]
    end if
end procedure
procedure Jelvv(atom a, integer b, integer rv)
    if a = variables[b] then
	ip = variables[rv]
    end if
end procedure
procedure Jevvv(integer a, integer b, integer rv)
    if variables[a] = variables[b] then
	ip = variables[rv]
    end if
end procedure
procedure Jnellv(atom a, atom b, integer rv)
    if a != b then
	ip = variables[rv]
    end if
end procedure
procedure Jnevlv(integer a, atom b, integer rv)
    if variables[a] != b then
	ip = variables[rv]
    end if
end procedure
procedure Jnelvv(atom a, integer b, integer rv)
    if a != variables[b] then
	ip = variables[rv]
    end if
end procedure
procedure Jnevvv(integer a, integer b, integer rv)
    if variables[a] != variables[b] then
	ip = variables[rv]
    end if
end procedure
procedure Jlllv(atom a, atom b, integer rv)
    if a < b then
	ip = variables[rv]
    end if
end procedure
procedure Jlvlv(integer a, atom b, integer rv)
    if variables[a] < b then
	ip = variables[rv]
    end if
end procedure
procedure Jllvv(atom a, integer b, integer rv)
    if a < variables[b] then
	ip = variables[rv]
    end if
end procedure
procedure Jlvvv(integer a, integer b, integer rv)
    if variables[a] < variables[b] then
	ip = variables[rv]
    end if
end procedure
procedure Jgllv(atom a, atom b, integer rv)
    if a > b then
	ip = variables[rv]
    end if
end procedure
procedure Jgvlv(integer a, atom b, integer rv)
    if variables[a] > b then
	ip = variables[rv]
    end if
end procedure
procedure Jglvv(atom a, integer b, integer rv)
    if a > variables[b] then
	ip = variables[rv]
    end if
end procedure
procedure Jgvvv(integer a, integer b, integer rv)
    if variables[a] > variables[b] then
	ip = variables[rv]
    end if
end procedure
procedure Jlellv(atom a, atom b, integer rv)
    if a <= b then
	ip = variables[rv]
    end if
end procedure
procedure Jlevlv(integer a, atom b, integer rv)
    if variables[a] <= b then
	ip = variables[rv]
    end if
end procedure
procedure Jlelvv(atom a, integer b, integer rv)
    if a <= variables[b] then
	ip = variables[rv]
    end if
end procedure
procedure Jlevvv(integer a, integer b, integer rv)
    if variables[a] <= variables[b] then
	ip = variables[rv]
    end if
end procedure
procedure Jgellv(atom a, atom b, integer rv)
    if a >= b then
	ip = variables[rv]
    end if
end procedure
procedure Jgevlv(integer a, atom b, integer rv)
    if variables[a] >= b then
	ip = variables[rv]
    end if
end procedure
procedure Jgelvv(atom a, integer b, integer rv)
    if a >= variables[b] then
	ip = variables[rv]
    end if
end procedure
procedure Jgevvv(integer a, integer b, integer rv)
    if variables[a] >= variables[b] then
	ip = variables[rv]
    end if
end procedure
procedure Celll(atom a, atom b, integer rv)
    variables[rv] = (a = b)
end procedure
procedure Cevll(integer a, atom b, integer rv)
    variables[rv] = (variables[a] = b)
end procedure
procedure Celvl(atom a, integer b, integer rv)
    variables[rv] = (a = variables[b])
end procedure
procedure Cevvl(integer a, integer b, integer rv)
    variables[rv] = (variables[a] = variables[b])
end procedure
procedure Cnelll(atom a, atom b, integer rv)
    variables[rv] = (a != b)
end procedure
procedure Cnevll(integer a, atom b, integer rv)
    variables[rv] = (variables[a] != b)
end procedure
procedure Cnelvl(atom a, integer b, integer rv)
    variables[rv] = (a != variables[b])
end procedure
procedure Cnevvl(integer a, integer b, integer rv)
    variables[rv] = (variables[a] != variables[b])
end procedure
procedure Clelll(atom a, atom b, integer rv)
    variables[rv] = (a <= b)
end procedure
procedure Clevll(integer a, atom b, integer rv)
    variables[rv] = (variables[a] <= b)
end procedure
procedure Clelvl(atom a, integer b, integer rv)
    variables[rv] = (a <= variables[b])
end procedure
procedure Clevvl(integer a, integer b, integer rv)
    variables[rv] = (variables[a] <= variables[b])
end procedure
procedure Cgelll(atom a, atom b, integer rv)
    variables[rv] = (a >= b)
end procedure
procedure Cgevll(integer a, atom b, integer rv)
    variables[rv] = (variables[a] >= b)
end procedure
procedure Cgelvl(atom a, integer b, integer rv)
    variables[rv] = (a >= variables[b])
end procedure
procedure Cgevvl(integer a, integer b, integer rv)
    variables[rv] = (variables[a] >= variables[b])
end procedure
procedure Cllll(atom a, atom b, integer rv)
    variables[rv] = (a < b)
end procedure
procedure Clvll(integer a, atom b, integer rv)
    variables[rv] = (variables[a] < b)
end procedure
procedure Cllvl(atom a, integer b, integer rv)
    variables[rv] = (a < variables[b])
end procedure
procedure Clvvl(integer a, integer b, integer rv)
    variables[rv] = (variables[a] < variables[b])
end procedure
procedure Cglll(atom a, atom b, integer rv)
    variables[rv] = (a > b)
end procedure
procedure Cgvll(integer a, atom b, integer rv)
    variables[rv] = (variables[a] > b)
end procedure
procedure Cglvl(atom a, integer b, integer rv)
    variables[rv] = (a > variables[b])
end procedure
procedure Cgvvl(integer a, integer b, integer rv)
    variables[rv] = (variables[a] > variables[b])
end procedure
procedure Cmplll(object a, object b, integer rv)
    variables[rv] = compare(a,b)
end procedure
procedure Cmpvll(integer a, object b, integer rv)
    variables[rv] = compare(variables[a], b)
end procedure
procedure Cmplvl(object a, integer b, integer rv)
    variables[rv] = compare(a, variables[b])
end procedure
procedure Cmpvvl(integer a, integer b, integer rv)
    variables[rv] = compare(variables[a], variables[b])
end procedure
procedure Equlll(object a, object b, integer rv)
    variables[rv] = equal(a, b)
end procedure
procedure Equvll(integer a, object b, integer rv)
    variables[rv] = equal(variables[a], b)
end procedure
procedure Equlvl(object a, integer b, integer rv)
    variables[rv] = equal(a, variables[b])
end procedure
procedure Equvvl(integer a, integer b, integer rv)
    variables[rv] = equal(variables[a], variables[b])
end procedure
procedure Ret()
    ip = callstack[length(callstack)]
    callstack = callstack[1..length(callstack)-1]
end procedure
procedure Jmpl(integer x)
    ip = x
end procedure
procedure Jmpv(integer x)
    ip = variables[x]
end procedure
procedure End()
    abort(0)
end procedure
procedure Errl(integer x)
    printf(1,"ERROR: Error code %d\n",x)
end procedure
procedure Errv(integer x)
    printf(1,"ERROR: Error code %d\n",variables[x])
end procedure
procedure Pushl(object x)
    stack = append(stack,x)
end procedure
procedure Pushv(integer x)
    stack = append(stack,variables[x])
end procedure
procedure Popl(integer v)
    variables[v] = stack[length(stack)]
    stack = stack[1..length(stack)-1]
end procedure
procedure Ldssl(integer v)
    variables[v] = length(stack)
end procedure
constant UPPER = "ABCDEFGHIJKLMNOPQRSTUVWXYZ"
constant LOWER = "abcdefghijklmnopqrstuvwxyz"
function GenerateRoutineIDs()
    sequence s, name
    s = {}
    for i = 1 to length(OPCODES) do
	name = OPCODES[i][1]
	name[1] = UPPER[find(name[1],LOWER)]
	for j = 1 to length(OPCODES[i][3]) do
	    if OPCODES[i][3][j] = VAL then
		name &= 'l'
	    else
		name &= 'v'
	    end if
	end for
	s &= routine_id(name)
	if s[i] = -1 then
	    puts(1,"Couldn't find " & name & ".\n")
	    abort(0)
	end if
    end for
    return s
end function
constant ROUTINES = GenerateRoutineIDs()
procedure run()
    sequence c
    ip = 1
    stack = {}
    callstack = {}
    while 1 do
	c = code[ip]
	ip += 1
	call_proc(c[1],c[2])
	c = code[ip]
	ip += 1
	call_proc(c[1],c[2])
	c = code[ip]
	ip += 1
	call_proc(c[1],c[2])
	c = code[ip]
	ip += 1
	call_proc(c[1],c[2])
	c = code[ip]
	ip += 1
	call_proc(c[1],c[2])
	c = code[ip]
	ip += 1
	call_proc(c[1],c[2])
	c = code[ip]
	ip += 1
	call_proc(c[1],c[2])
	c = code[ip]
	ip += 1
	call_proc(c[1],c[2])
	c = code[ip]
	ip += 1
	call_proc(c[1],c[2])
	c = code[ip]
	ip += 1
	call_proc(c[1],c[2])
    end while
end procedure
procedure readCode(integer f, integer n)
    integer op
    sequence args
    code = {}
    if n then
	for i = 1 to n do
	    op = getc(f)
	    args = repeat(0,length(OPCODES[op+1][3]))
	    for j = 1 to length(args) do
		args[j] = ReadValue(f)
	    end for
	    code = append(code,{ROUTINES[op+1],args})
	end for
    end if
end procedure
procedure loadFile(sequence s)
    integer f
    f = open(s,"rb")
    variables = repeat(0,ReadValue(f))
    readCode(f,ReadValue(f))
    close(f)
end procedure
sequence cl
cl = command_line()
puts(1,"Loading...\n")
loadFile(cl[3])
run()

